<?php
class ControllerExtensionShippingSmilePayShippingC2CP extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/shipping/smilePay_shipping_c2cp');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('shipping_smilePay_shipping_c2cp', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=shipping', true));
		}

		$data['heading_title'] = $this->language->get('heading_title');
		
		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_all_zones'] = $this->language->get('text_all_zones');
		$data['text_none'] = $this->language->get('text_none');

		$data['entry_cost'] = $this->language->get('entry_cost');
		$data['entry_tax_class'] = $this->language->get('entry_tax_class');
		$data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

        // SmilePay data start
        $data['entry_max_total_cost'] = $this->language->get('entry_max_total_cost');
		$data['entry_min_total_cost'] = $this->language->get('entry_min_total_cost');
		$data['entry_limited_note'] = $this->language->get('entry_limited_note');
		$data['entry_enough_free'] = $this->language->get('entry_enough_free');
		$data['entry_cost_note'] = $this->language->get('entry_cost_note');
        $data['entry_frontend_title'] = $this->language->get('entry_frontend_title');
        //SmilePay data end

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

      
        //smilePay error data start
        if (isset($this->error['min_cost_over'])) {
			$data['error_min_cost_over'] = $this->error['min_cost_over'];
		} else {
			$data['error_min_cost_over'] = '';
		}
        
        if (isset($this->error['max_cost_over'])) {
			$data['error_max_cost_over'] = $this->error['max_cost_over'];
		} else {
			$data['error_max_cost_over'] = '';
		}
        if (isset($this->error['max_min_rule'])) {
			$data['error_max_min_rule'] = $this->error['max_min_rule'];
		} else {
			$data['error_max_min_rule'] = '';
		}

        if (isset($this->error['711_cost'])) {
			$data['error_711_cost'] = $this->error['711_cost'];
		} else {
			$data['error_711_cost'] = '';
		}
        if (isset($this->error['fami_cost'])) {
			$data['error_fami_cost'] = $this->error['fami_cost'];
		} else {
			$data['error_fami_cost'] = '';
		}


        /*if (isset($this->error['cost'])) {
			$data['error_cost'] = $this->error['cost'];
		} else {
			$data['error_cost'] = '';
		}*/

        //smilePay error data end
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_shipping'),
			'href' =>$this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=shipping', true),
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/shipping/smilePay_shipping_c2cp', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['action'] = $this->url->link('extension/shipping/smilePay_shipping_c2cp', 'user_token=' . $this->session->data['user_token'], true);

		$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=shipping', true);

		/*if (isset($this->request->post['shipping_smilePay_shipping_c2cp_cost'])) {
			$data['shipping_smilePay_shipping_c2cp_cost'] = $this->request->post['shipping_smilePay_shipping_c2cp_cost'];
		} else {
			$data['shipping_smilePay_shipping_c2cp_cost'] = $this->config->get('shipping_smilePay_shipping_c2cp_cost');
		}*/

	
		$this->load->model('localisation/tax_class');


		if (isset($this->request->post['shipping_smilePay_shipping_c2cp_geo_zone_id'])) {
			$data['shipping_smilePay_shipping_c2cp_geo_zone_id'] = $this->request->post['shipping_smilePay_shipping_c2cp_geo_zone_id'];
		} else {
			$data['shipping_smilePay_shipping_c2cp_geo_zone_id'] = $this->config->get('shipping_smilePay_shipping_c2cp_geo_zone_id');
		}

		$this->load->model('localisation/geo_zone');

		$data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

		if (isset($this->request->post['shipping_smilePay_shipping_c2cp_status'])) {
			$data['shipping_smilePay_shipping_c2cp_status'] = $this->request->post['shipping_smilePay_shipping_c2cp_status'];
		} else {
			$data['shipping_smilePay_shipping_c2cp_status'] = $this->config->get('shipping_smilePay_shipping_c2cp_status');
		}

		if (isset($this->request->post['shipping_smilePay_shipping_c2cp_sort_order'])) {
			$data['shipping_smilePay_shipping_c2cp_sort_order'] = $this->request->post['shipping_smilePay_shipping_c2cp_sort_order'];
		} else {
			$data['shipping_smilePay_shipping_c2cp_sort_order'] = $this->config->get('shipping_smilePay_shipping_c2cp_sort_order');
		}
        //smilepay start
        
		if (isset($this->request->post['shipping_smilePay_shipping_c2cp_max_total_cost'])) {
			$data['shipping_smilePay_shipping_c2cp_max_total_cost'] = $this->request->post['shipping_smilePay_shipping_c2cp_max_total_cost'];
		} else {
			$data['shipping_smilePay_shipping_c2cp_max_total_cost'] = $this->config->get('shipping_smilePay_shipping_c2cp_max_total_cost');
		}
        if (isset($this->request->post['shipping_smilePay_shipping_c2cp_min_total_cost'])) {
			$data['shipping_smilePay_shipping_c2cp_min_total_cost'] = $this->request->post['shipping_smilePay_shipping_c2cp_min_total_cost'];
		} else {
			$data['shipping_smilePay_shipping_c2cp_min_total_cost'] = $this->config->get('shipping_smilePay_shipping_c2cp_min_total_cost');
		}
        if (isset($this->request->post['shipping_smilePay_shipping_c2cp_free_cost'])) {
			$data['shipping_smilePay_shipping_c2cp_free_cost'] = $this->request->post['shipping_smilePay_shipping_c2cp_free_cost'];
		} else {
			$data['shipping_smilePay_shipping_c2cp_free_cost'] = $this->config->get('shipping_smilePay_shipping_c2cp_free_cost');
		}
        
        if (isset($this->request->post['shipping_smilePay_shipping_c2cp_free_cost'])) {
			$data['shipping_smilePay_shipping_c2cp_free_cost'] = $this->request->post['shipping_smilePay_shipping_c2cp_free_cost'];
		} else {
			$data['shipping_smilePay_shipping_c2cp_free_cost'] = $this->config->get('shipping_smilePay_shipping_c2cp_free_cost');
		}
        

        if (isset($this->request->post['shipping_smilePay_shipping_c2cp_frontend_title'])) {
			$data['shipping_smilePay_shipping_c2cp_frontend_title'] = $this->request->post['shipping_smilePay_shipping_c2cp_frontend_title'];
		} else {
            if($this->config->get('shipping_smilePay_shipping_c2cp_frontend_title'))
			    $data['shipping_smilePay_shipping_c2cp_frontend_title'] = $this->config->get('shipping_smilePay_shipping_c2cp_frontend_title');
            else
                $data['shipping_smilePay_shipping_c2cp_frontend_title'] =  $this->language->get('heading_title');
		}
       
        //smilepay end

        // 711 start
        if (isset($this->request->post['shipping_smilePay_shipping_c2cp_711_enabled'])) {
			$data['shipping_smilePay_shipping_c2cp_711_enabled'] = $this->request->post['shipping_smilePay_shipping_c2cp_711_enabled'];
		} else {
			$data['shipping_smilePay_shipping_c2cp_711_enabled'] = $this->config->get('shipping_smilePay_shipping_c2cp_711_enabled');
		}
        if (isset($this->request->post['shipping_smilePay_shipping_c2cp_cost'])) {
			$data['shipping_smilePay_shipping_c2cp_cost'] = $this->request->post['shipping_smilePay_shipping_c2cp_cost'];
		} else {
			$data['shipping_smilePay_shipping_c2cp_cost'] = $this->config->get('shipping_smilePay_shipping_c2cp_cost');
		}

        if (isset($this->request->post['shipping_smilePay_shipping_c2cp_711_frontend_title'])) {
			$data['shipping_smilePay_shipping_c2cp_711_frontend_title'] = $this->request->post['shipping_smilePay_shipping_c2cp_711_frontend_title'];
		} else {
            if($this->config->get('shipping_smilePay_shipping_c2cp_711_frontend_title'))
			    $data['shipping_smilePay_shipping_c2cp_711_frontend_title'] = $this->config->get('shipping_smilePay_shipping_c2cp_711_frontend_title');
            else
                $data['shipping_smilePay_shipping_c2cp_711_frontend_title'] =  $this->language->get('title_711');
		}
        // 711 end

        // fami start
        if (isset($this->request->post['shipping_smilePay_shipping_c2cp_fami_enabled'])) {
			$data['shipping_smilePay_shipping_c2cp_fami_enabled'] = $this->request->post['shipping_smilePay_shipping_c2cp_fami_enabled'];
		} else {
			$data['shipping_smilePay_shipping_c2cp_fami_enabled'] = $this->config->get('shipping_smilePay_shipping_c2cp_fami_enabled');
		}
        if (isset($this->request->post['shipping_smilePay_shipping_c2cp_fami_cost'])) {
			$data['shipping_smilePay_shipping_c2cp_fami_cost'] = $this->request->post['shipping_smilePay_shipping_c2cp_fami_cost'];
		} else {
			$data['shipping_smilePay_shipping_c2cp_fami_cost'] = $this->config->get('shipping_smilePay_shipping_c2cp_fami_cost');
		}

        if (isset($this->request->post['shipping_smilePay_shipping_c2cp_fami_frontend_title'])) {
			$data['shipping_smilePay_shipping_c2cp_fami_frontend_title'] = $this->request->post['shipping_smilePay_shipping_c2cp_fami_frontend_title'];
		} else {
            if($this->config->get('shipping_smilePay_shipping_c2cp_fami_frontend_title'))
			    $data['shipping_smilePay_shipping_c2cp_fami_frontend_title'] = $this->config->get('shipping_smilePay_shipping_c2cp_fami_frontend_title');
            else
                $data['shipping_smilePay_shipping_c2cp_fami_frontend_title'] =  $this->language->get('title_fami');
		}
        // 711 end



		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/shipping/smilePay_shipping_c2cp', $data));
	}

	protected function validate() {

         // default  cost 60-19999
        define("SMILEPAY_SHIPPING_MIN_TOTOAL_COST_RANGE",60);
        define("SMILEPAY_SHIPPING_MAX_TOTOAL_COST_RANGE",19999);

        $max_cost_check_ok=false;
        $min_cost_check_ok=false;

		if (!$this->user->hasPermission('modify', 'extension/shipping/smilePay_shipping_c2cp')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
      
        if( $this->request->post['shipping_smilePay_shipping_c2cp_min_total_cost']  )
        {
       //    $log= new Log("mytest.log");
         
          if($this->request->post['shipping_smilePay_shipping_c2cp_min_total_cost']  < SMILEPAY_SHIPPING_MIN_TOTOAL_COST_RANGE || $this->request->post['shipping_smilePay_shipping_c2cp_min_total_cost']>SMILEPAY_SHIPPING_MAX_TOTOAL_COST_RANGE)
          {
              $this->error['min_cost_over'] = $this->language->get('error_min_cost_over');
             
          }
          else
           $min_cost_check_ok=true;
              
           // $log->write($this->error['mincostover'] );
        }
        

        if( $this->request->post['shipping_smilePay_shipping_c2cp_max_total_cost'])
        {
          if($this->request->post['shipping_smilePay_shipping_c2cp_max_total_cost']  >SMILEPAY_SHIPPING_MAX_TOTOAL_COST_RANGE || $this->request->post['shipping_smilePay_shipping_c2cp_max_total_cost'] <SMILEPAY_SHIPPING_MIN_TOTOAL_COST_RANGE ) 
          {
              $this->error['max_cost_over'] = $this->language->get('error_max_cost_over');
              
          }
          else
            $max_cost_check_ok =true;
        }
      
        if($max_cost_check_ok &&  $min_cost_check_ok)
        {
            if($this->request->post['shipping_smilePay_shipping_c2cp_max_total_cost']  < $this->request->post['shipping_smilePay_shipping_c2cp_min_total_cost'])
              $this->error['max_min_rule'] = $this->language->get('error_max_min_rule');
        }
        
       //if( !isset( $this->request->post['shipping_smilePay_shipping_c2cp_cost']) || $this->request->post['shipping_smilePay_shipping_c2cp_cost']=="" || $this->request->post['shipping_smilePay_shipping_c2cp_cost']<0 )
        //$this->error['cost']= $this->language->get('error_cost');
        if( $this->request->post['shipping_smilePay_shipping_c2cp_711_enabled'] != 0 && (!isset( $this->request->post['shipping_smilePay_shipping_c2cp_cost']) || $this->request->post['shipping_smilePay_shipping_c2cp_cost']=="" || $this->request->post['shipping_smilePay_shipping_c2cp_cost']<0) )
            $this->error['711_cost']= $this->language->get('error_cost');

        if( $this->request->post['shipping_smilePay_shipping_c2cp_fami_enabled'] != 0 && (!isset( $this->request->post['shipping_smilePay_shipping_c2cp_fami_cost']) || $this->request->post['shipping_smilePay_shipping_c2cp_fami_cost']=="" || $this->request->post['shipping_smilePay_shipping_c2cp_fami_cost']<0) )
            $this->error['fami_cost']= $this->language->get('error_cost');


		return !$this->error;
	}


    public function install() {
			$this->load->model('setting/event');
			$this->model_setting_event->addEvent('smilePay_shipping_c2cp_filter', 'catalog/view/checkout/payment_method/before', 'extension/module/smilepay_ext/filter_payment_c2cp');
	}

	public function uninstall() {
		$this->load->model('setting/event');
		$this->model_setting_event->deleteEventByCode('smilePay_shipping_c2cp_filter');
	}



}